"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const koishi_1 = require("koishi");
class StarRailCommander {
    constructor(ctx, config) {
        this.ctx = ctx;
        this.config = config;
        //#region commands
        ctx.starrail.subcommand('uid <uid>')
            .option('default', '-d')
            .option('remove', '-r')
            .userFields(['sr_uid'])
            .action(async ({ session, options }, uid) => {
            if (options.default) {
                session.user.sr_uid = uid;
                return session.text('.def', [uid]);
            }
            else if (options.remove) {
                if (session.user.sr_uid === uid) {
                    await session.send(session.text('.remove-def', [uid]));
                    const dot = await session.prompt(1500);
                    if (/\.|。/.test(dot)) {
                        return session.text('.removed-def');
                    }
                    return session.text('.timeout');
                }
                return session.text('.removed', [uid]);
            }
            if (session.user.sr_uid) {
                //
            }
            else {
                session.user.sr_uid = uid;
                //
                return session.text('.binded') + session.text('.frist', [uid]);
            }
        });
        ctx.starrail.subcommand('cookie [uid]')
            .option('bind', '-b')
            .option('remove', '-r')
            .action(async () => {
        });
        ctx.starrail.subcommand('bind <uid:string>')
            .alias('星铁绑定')
            .action(async ({ session }, uid) => {
            var _a;
            if (!uid) {
                session.send('请输入uid');
                uid = await session.prompt();
            }
            if (!uid)
                return;
            const session_user = session;
            const uid_base = (_a = (await this.ctx.starrail.getUid(session_user.user.id))[0]) === null || _a === void 0 ? void 0 : _a.uid;
            let user_enable = false;
            if (uid_base)
                user_enable = true;
            await this.ctx.starrail.setUid(session_user.user.id, uid, user_enable);
            return '绑定成功';
        });
        //#endregion
    }
    defineCommand(command, type, ...args) {
        const def = type === 'subset' ? `sr.${command}` : `sr/${command}`;
        const desc = typeof args[0] === 'string' ? args.shift() : '';
        const config = args[0] || {};
        return this.ctx.command(def, desc, config);
    }
    subcommand(def, ...args) {
        return this.defineCommand(def, 'subset', ...args);
    }
    dercommand(def, ...args) {
        return this.defineCommand(def, 'derive', ...args);
    }
}
StarRailCommander.using = ['starrail'];
(function (StarRailCommander) {
    StarRailCommander.Config = koishi_1.Schema.object({}).description('命令设置');
})(StarRailCommander || (StarRailCommander = {}));
exports.default = StarRailCommander;
