import { Model } from "koishi";
import { Context, Field, Observed as OB } from "koishi";
export interface StarRail {
    id: number;
    uid: string;
    doken: string;
    cookie: string;
}
declare module 'koishi' {
    interface User {
        sr_uid: string;
    }
    interface Binding {
        sr: number[];
    }
    interface Tables {
        star_rail: StarRail.Database;
    }
}
export declare namespace StarRail {
    type Field = keyof StarRail;
    const fields: Field[];
    type Observed<K extends Field = Field> = OB<Pick<StarRail, K>, Promise<void>>;
    interface Database {
        id: number;
        uid: string;
        doken: string;
        cookie: string;
    }
}
declare class StarRailDatabase {
    private app;
    constructor(app: Context);
    /**
    * WIP
    */
    getUid(id: number): Promise<Pick<StarRail, "uid">[]>;
    setUid(id: number, srUid: string, def?: boolean): Promise<void>;
    getStarFields(fields: Field<StarRail.Field>): StarRail.Observed;
    extendDatabase(fields: Field.Extension<StarRail>, config?: Partial<Model.Config<StarRail>>): void;
}
export default StarRailDatabase;
